#include "lsjpg.h"

void
xyConv (char *xy, IMG * image)
{
  extern Display *d;
  extern Window big_window;
  extern GC gc_big;

  int (*fncptr) ();
  Window statusbar;
  XWindowAttributes xwa;

  int a_, b_, c_, d_, e_, f_, g_, h_, i_;
  int ii, jj;
  int generation;
  int width = image->width, height = image->height;
  int *tmp;

  tmp = (int *) malloc (sizeof (int) * width * height * 3);

  if (*xy == 'x')
    fncptr = xCellAtm;
  else
    fncptr = yCellAtm;

  XGetWindowAttributes (d, big_window, &xwa);
  statusbar =
    XCreateSimpleWindow (d, big_window, 0, 0, xwa.width, 10, 1,
			 BlackPixel (d, 0), WhitePixel (d, 0));
  XMapSubwindows (d, big_window);
  XDefineCursor (d, big_window, XCreateFontCursor (d, XC_watch));
  XDrawRectangle (d, statusbar, gc_big, 2, 1, xwa.width - 6, 7);
  XFlush (d);

  tmp = (int *) malloc (sizeof (int) * width * height * 3);

  for (generation = 0; generation < X_GENERATION; generation++) {
    for (ii = 0; ii < width * height * 3; ii++)
      tmp[ii] = image->data[ii];

    for (ii = 1; ii < height - 1; ii++) {
      for (jj = 1; jj < width - 1; jj++) {
	e_ = ii * width * 3 + jj * 3;

	a_ = e_ - 3 * width - 3;
	b_ = e_ - 3 * width;
	c_ = e_ - 3 * width + 3;
	d_ = e_ - 3;
	f_ = e_ + 3;
	g_ = e_ + 3 * width - 3;
	h_ = e_ + 3 * width;
	i_ = e_ + 3 * width + 3;

	image->data[e_] =
	  (*fncptr) (tmp[a_], tmp[b_], tmp[c_],
		     tmp[d_], tmp[e_], tmp[f_], tmp[g_], tmp[h_], tmp[i_]);

	image->data[e_ + 1] =
	  (*fncptr) (tmp[a_ + 1],
		     tmp[b_ + 1],
		     tmp[c_ + 1],
		     tmp[d_ + 1],
		     tmp[e_ + 1],
		     tmp[f_ + 1], tmp[g_ + 1], tmp[h_ + 1], tmp[i_ + 1]);

	image->data[e_ + 2] =
	  (*fncptr) (tmp[a_ + 2],
		     tmp[b_ + 2],
		     tmp[c_ + 2],
		     tmp[d_ + 2],
		     tmp[e_ + 2],
		     tmp[f_ + 2], tmp[g_ + 2], tmp[h_ + 2], tmp[i_ + 2]);
      }
      XFillRectangle (d, statusbar, gc_big, 2, 1,
		      (xwa.width - 6) * (generation * (height - 2) + ii)
		      / (X_GENERATION * (height - 2)), 7);
      XFlush (d);
    }
  }

  free (tmp);
  XDefineCursor (d, big_window, XCreateFontCursor (d, XC_left_ptr));
  XDestroySubwindows (d, big_window);
}

int
xCellAtm (int a, int b, int c, int d, int e, int f, int g, int h, int i)
{
  int nbr = 0;

  if (a > e)
    nbr++;
  if (b > e)
    nbr++;
  if (c > e)
    nbr++;
  if (d > e)
    nbr++;
  if (f > e)
    nbr++;
  if (g > e)
    nbr++;
  if (h > e)
    nbr++;
  if (i > e)
    nbr++;

  if (nbr < 3)
    if (e > 0)
      return e - 1;
    else
      return e;
  else if (nbr > 3)
    if (e < 255)
      return e + 1;
    else
      return e;
  else
    return e;
}

int
yCellAtm (int a, int b, int c, int d, int e, int f, int g, int h, int i)
{
  int val;
  int nbr = 0;

  if (a > e)
    nbr++;
  if (b > e)
    nbr++;
  if (c > e)
    nbr++;
  if (d > e)
    nbr++;
  if (f > e)
    nbr++;
  if (g > e)
    nbr++;
  if (h > e)
    nbr++;
  if (i > e)
    nbr++;

  val = e + nbr;

  if (val < 255)
    return val;
  else
    return 255;
}

void
XZanim (char *XZ, IMG * image)
{
  extern int depth;
  extern Display *d;
  extern Visual *visual;
  extern Window big_window;

  int a_, b_, c_, d_, e_, f_, g_, h_, i_;
  int ii, jj;
  int width = image->width, height = image->height, gen;
  int *tmp;
  int (*fncptr) ();
  XImage *xim;
  XEvent event;
  XWindowAttributes xwa;
  XClientMessageEvent *client_event;
  Window statusbar;
  Atom delw;
  XColor color;
  Colormap default_cmap;
  XGCValues xGCv;
  GC gc;
  unsigned long fgpix;

  if (*XZ == 'X')
    fncptr = XCellAtm;
  else
    fncptr = ZCellAtm;

  /* status bar */
  default_cmap = DefaultColormap (d, DefaultScreen (d));
  XParseColor (d, default_cmap, "red", &color);
  XAllocColor (d, default_cmap, &color);
  fgpix = color.pixel;
  xGCv.foreground = fgpix;
  XGetWindowAttributes (d, big_window, &xwa);
  statusbar =
    XCreateSimpleWindow (d, big_window, 0, 0, xwa.width, 10, 1,
			 BlackPixel (d, 0), WhitePixel (d, 0));
  gc = XCreateGC (d, statusbar, GCForeground, &xGCv);
  XMapSubwindows (d, big_window);
  XDefineCursor (d, big_window, XCreateFontCursor (d, XC_gumby));
  delw = XInternAtom (d, "WM_DELETE_WINDOW", FALSE);

  XStoreName (d, big_window, "Button-3 to stop");

  tmp = (int *) malloc (sizeof (int) * width * height * 3);

  while (1) {
    for (gen = 0; gen < ANIM_GENERATION; gen++) {
      if (XEventsQueued (d, QueuedAfterReading)) {	/* DONE? */
	XNextEvent (d, &event);
	client_event = (XClientMessageEvent *) & event;

	if ((event.type == ButtonPress && event.xbutton.button == Button3)
	    || (event.type == ClientMessage
		&& client_event->data.l[0] == delw)) {
	  goto DONE;		/* exit while(1) loop */
	}
      }
      XDrawRectangle (d, statusbar, gc, 2, 1, xwa.width - 6, 7);

      for (ii = 0; ii < width * height * 3; ii++)
	tmp[ii] = image->data[ii];

      xim = makeXimage (d, visual, depth, image);
      XPutImage (d, big_window, gc, xim, 0, 0, 0, 0, xim->width, xim->height);
      XDestroyImage (xim);

      for (ii = 1; ii < height - 1; ii++) {
	for (jj = 1; jj < width - 1; jj++) {
	  e_ = ii * width * 3 + jj * 3;

	  a_ = e_ - 3 * width - 3;
	  b_ = e_ - 3 * width;
	  c_ = e_ - 3 * width + 3;
	  d_ = e_ - 3;
	  f_ = e_ + 3;
	  g_ = e_ + 3 * width - 3;
	  h_ = e_ + 3 * width;
	  i_ = e_ + 3 * width + 3;

	  image->data[e_] =
	    (*fncptr) (tmp[a_], tmp[b_], tmp[c_],
		       tmp[d_], tmp[e_], tmp[f_], tmp[g_], tmp[h_], tmp[i_]);
	  image->data[e_ + 1] =
	    (*fncptr) (tmp[a_ + 1], tmp[b_ + 1], tmp[c_ + 1],
		       tmp[d_ + 1], tmp[e_ + 1], tmp[f_ + 1],
		       tmp[g_ + 1], tmp[h_ + 1], tmp[i_ + 1]);
	  image->data[e_ + 2] =
	    (*fncptr) (tmp[a_ + 2], tmp[b_ + 2], tmp[c_ + 2],
		       tmp[d_ + 2], tmp[e_ + 2], tmp[f_ + 2],
		       tmp[g_ + 2], tmp[h_ + 2], tmp[i_ + 2]);
	}
      }
      XFillRectangle (d, statusbar, gc, 2, 1,
		      (xwa.width - 6) * (gen + 1) / ANIM_GENERATION, 7);
    }
    XClearWindow (d, statusbar);
  }				/* while(1) */

DONE:
  free (tmp);

  XStoreName (d, big_window, "DONE");

  XDefineCursor (d, big_window, XCreateFontCursor (d, XC_left_ptr));
  XDestroySubwindows (d, big_window);

  XMapRaised (d, big_window);
}

int
XCellAtm (int a, int b, int c, int d, int e, int f, int g, int h, int i)
{
  int nbr = 0;

  if (a > e)
    nbr++;
  if (b > e)
    nbr++;
  if (c > e)
    nbr++;
  if (d > e)
    nbr++;
  if (f > e)
    nbr++;
  if (g > e)
    nbr++;
  if (h > e)
    nbr++;
  if (i > e)
    nbr++;

  if (nbr < 2 || 3 < nbr)
    if (e > 1)
      return e - 1;
    else
      return 255;
  else if (nbr == 2)
    return e;
  else if (e < 255)
    return e + 1;
  else
    return 0;
}

int
ZCellAtm (int a, int b, int c, int d, int e, int f, int g, int h, int i)
{
  int nbr = 0;

  if (a > 128)
    nbr++;
  if (b > 128)
    nbr++;
  if (c > 128)
    nbr++;
  if (d > 128)
    nbr++;
  if (f > 128)
    nbr++;
  if (g > 128)
    nbr++;
  if (h > 128)
    nbr++;
  if (i > 128)
    nbr++;

  if (nbr < 2 || 3 < nbr)
    return 0;
  else if (nbr == 2)
    return e;
  else				/* nbr == 3 */
    return 255;
}
