
#include "lsjpg.h"

#define SORRY_8BPP "lsjpg: initialize: Sorry, program does not support 8-bpp mode.\nPlease try 16-bpp or 24-bpp mode instead\n"
#define ERROR_VISUAL "lsjpg: initialize: Can't find matching visual.(depth:%d, TrueColor)\n"
int
initialize ()
{
  extern int depth;
  extern Visual *visual;
  extern Display *d;

  char *display;
  XVisualInfo vis_info;

  display = (char *) getenv ("DISPLAY");
  if ((d = XOpenDisplay (display)) == NULL) {
    fprintf (stderr, "lsjpg: Can't open display: %s\n", display);
    return FAILED;
  }
  depth = DefaultDepth (d, 0);

  if (depth == 8) {
    fprintf (stderr, SORRY_8BPP);
    return FAILED;
  }
  if (!XMatchVisualInfo (d, DefaultScreen (d), depth, TrueColor, &vis_info)) {
    fprintf (stderr, ERROR_VISUAL, depth);
    return FAILED;
  }
  visual = vis_info.visual;

  return SUCCESS;
}
