#include "lsjpg.h"

/* Globals */
Display *d;
Visual *visual;
Window thumb_window, vscroll, big_window, menu_window, pmenu_window;
GC gc_big, gc_clip, gc_paint;
Pixmap background_pmap, thumb_pmap, big_pmap;
XImage *thumb_image[MAX_IMAGE], *big_image;
IMG *image;
char fname[MAX_IMAGE][FILENAME_LENGTH], dname[MAX_IMAGE][FILENAME_LENGTH];
int depth;
int size_prop_factor = 5, original_image_size, xs0, ys0, xs, ys, xe, ye;
int thumb_height = THUMB_HEIGHT, border_width = THUMB_PITCH;
int thumb_offset = 0, n_image, selected_image = -1;
int pos[MAX_IMAGE][2], xwa_thumb_width, xwa_thumb_height;
int key_buffer = 5, quality = JPEG_QUALITY;
unsigned status;
unsigned paint_mode_type = PMODE_PAINT;

int
main (int argc, char **argv)
{
  int optind;
  XEvent event;

  if (initialize () == FAILED)
    exit (1);

  setOptionParams ();
  optind = handleArgs (argc, argv);
  n_image = getImages (optind, argc, argv);
  prepareThumbwindow ();

  if (n_image == 1) {
    selected_image = 0;
    displaySelectedImage ();
  }

  while (1) {
    XNextEvent (d, &event);
    /* if (status & DEBUG)
     *   stdoutReceivedEvent (&event);  */

    if (status & EXIST_PUZZLE && event.xany.window == big_window) {
      handlePuzzleEvent (&event);
    }
    else if (handleCommonKey (&event) == 0) {
      if (event.xany.window == thumb_window)
	handleThumbWinEvent (&event);
      else if (event.xany.window == vscroll)
	handleVscroll (&event);
      else if (event.xany.window == big_window && status & EXIST_BIG_WINDOW)
	handleBigWinEvent (&event);
      else if (event.xany.window == menu_window && status & EXIST_MENU)
	handleMenuWindow (&event);
      else if (event.xany.window == pmenu_window && status & PAINT_MODE)
	handlePmenuWindow (&event);
    }
  }
}
