#include "lsjpg.h"

IMG *
resizeImage (IMG * image, int new_height)
{
  int new_width;
  int old_width = image->width;
  int old_height = image->height;
  int i, j;
  int icolor, shift, shift_max;
  float f, p, q;
  IMG *new = (IMG *) malloc (sizeof (IMG));

  new->height = new_height;
  new->width = new_width = old_width * ((float) new_height / old_height);
  new->data = (JSAMPLE *) malloc (new_width * new_height * 3);

  f = (float) old_height / new_height;

  shift_max = old_width * old_height * 3 - 1 - 2 - old_width * 3 - 3;

  for (i = 0; i < new_height; i++) {
    for (j = 0; j < new_width; j++) {
      p = f * j - (int) (f * j);
      q = f * i - (int) (f * i);

      shift = 3 * ((int) (f * j) + old_width * (int) (f * i));

      if (shift_max < shift)
	shift = shift_max;

      for (icolor = 0; icolor < 3; icolor++) {
	*(new->data + icolor) =
	  (1 - p) * (1 - q) * *(image->data + shift + icolor)
	  + p * (1 - q) * *(image->data + shift + icolor + 3)
	  + (1 - p) * q * *(image->data + shift + icolor +
			    old_width * 3) + p * q * *(image->data +
						       shift + icolor +
						       old_width * 3 + 3);
      }
      new->data += 3;
    }
  }

  new->data -= new_width * new_height * 3;
  return new;
}
