#include "lsjpg.h"

int
readXVPIC (char *filepath, IMG *image)
{
  FILE *in;
  int rc;
  int nx, ny, nc;
  int i, j;
  char buff[128];
  unsigned int c;

  if ((in = fopen (filepath, "r")) == NULL)
    return 0;

  fgets (buff, 128, in); /* P7 332 (?)*/

  while (1) {
    fgets (buff, 128, in);
    if (!strncmp (buff, "#END_OF_COMMENTS", 16))
      break;
  }

  rc = fscanf (in, "%d %d %d", &nx, &ny, &nc);

  if (rc != 3) {
    fprintf (stderr, ".xvpic file invalid?: %s: rc=%d", filepath, rc);
    fclose (in);
    return 0;
  }
  
  image->width = nx;
  image->height = ny;
  image->data = (JSAMPLE *) malloc (nx * ny * 3);

  for (i = 0; i < ny; i++) {
    for (j = 0; j < nx; j++) {
      fread (&c, 1, 1, in);
      *(image->data + 0 + 3 * j  +  3 * nx * i)
	= (((int)((c >> 5) & 0x07)) * 255) / 7; 
      *(image->data + 1 + 3 * j  +  3 * nx * i)
	= (((int)((c >> 2) & 0x07)) * 255) / 7;
      *(image->data + 2 + 3 * j  +  3 * nx * i)
	= (((int)((c >> 0) & 0x03)) * 255) / 3;
    }
  }

  fclose (in);
  return 1;
}
